
set echo on

CREATE PROCEDURE execute_with_binds( p_sql IN VARCHAR2, 
                                     p_bvs IN binds_ntt ) IS

   c BINARY_INTEGER := DBMS_SQL.OPEN_CURSOR;
   v ANYTYPE;
   r BINARY_INTEGER;
   i PLS_INTEGER;

BEGIN

   /* Parse... */
   DBMS_SQL.PARSE(c, p_sql, DBMS_SQL.NATIVE);

   /* Bind... */
   i := p_bvs.FIRST;
   WHILE i IS NOT NULL LOOP

      CASE p_bvs(i).value.getType(v)

         WHEN DBMS_TYPES.TYPECODE_NUMBER
         THEN 
            DBMS_SQL.BIND_VARIABLE( c,
                                    p_bvs(i).name, 
                                    p_bvs(i).value.accessNumber() );

         WHEN DBMS_TYPES.TYPECODE_VARCHAR2
         THEN 
            DBMS_SQL.BIND_VARIABLE( c,
                                    p_bvs(i).name,
                                    p_bvs(i).value.accessVarchar2() );

         WHEN DBMS_TYPES.TYPECODE_DATE
         THEN 
            DBMS_SQL.BIND_VARIABLE( c,
                                    p_bvs(i).name,
                                    p_bvs(i).value.accessDate() );

      END CASE;

      i := p_bvs.NEXT(i);

   END LOOP;

   /* Execute... */
   r := DBMS_SQL.EXECUTE(c);

   DBMS_SQL.CLOSE_CURSOR(c);

EXCEPTION
   WHEN CASE_NOT_FOUND THEN 
      DBMS_SQL.CLOSE_CURSOR(c);
      RAISE_APPLICATION_ERROR(-20000,'Oops, tried to bind invalid type');

END execute_with_binds;
/

