
set echo on

CREATE TABLE t 
( c1 INTEGER
, c2 VARCHAR2(1)
, c3 NUMBER
, c4 DATE
, c5 VARCHAR2(20)
);

DECLARE

   v_sql   VARCHAR2(1024);
   v_binds binds_ntt := binds_ntt();

BEGIN

   /* SQL string... */
   v_sql := 'INSERT INTO t VALUES (:c1, :c2, :c3, :c4, :c5)';

   /* Bind variables... */
   v_binds.EXTEND(5);
   v_binds(1) := binds_ot('c1', ANYDATA.convertNumber(1));
   v_binds(2) := binds_ot('c2', ANYDATA.convertVarchar2('A'));
   v_binds(3) := binds_ot('c3', ANYDATA.convertNumber(100.50));
   v_binds(4) := binds_ot('c4', ANYDATA.convertDate(DATE '2000-01-01'));
   v_binds(5) := binds_ot('c5', ANYDATA.convertVarchar2(RPAD('B',20,'B')));

   /* Execute... */
   execute_with_binds( v_sql, v_binds );

END;
/

col c2 format a2

SELECT * FROM t;    


