
set echo on
set serveroutput on

DECLARE

   PROCEDURE generic_procedure ( p_anydata IN ANYDATA ) IS

      v_typeinfo  ANYTYPE;
      v_typecode  PLS_INTEGER;
      v_typevalue VARCHAR2(128);
      v_typename  VARCHAR2(128);

   BEGIN

      /* Get typecode... */
      v_typecode := p_anydata.GetType(v_typeinfo);

      /* Determine typecode and access accordingly... */
      CASE v_typecode

         WHEN DBMS_TYPES.TYPECODE_VARCHAR2
         THEN
            v_typevalue := p_anydata.AccessVarchar2();
            v_typename  := 'VARCHAR2';

         WHEN DBMS_TYPES.TYPECODE_NUMBER
         THEN
            v_typevalue := TO_CHAR(p_anydata.AccessNumber());
            v_typename  := 'NUMBER';

         WHEN DBMS_TYPES.TYPECODE_DATE
         THEN
            v_typevalue := TO_CHAR(p_anydata.AccessDate(),'DD-MON-YYYY');
            v_typename  := 'DATE';

      END CASE;

      /* Output... */
      DBMS_OUTPUT.PUT_LINE('--------------------------------------');
      DBMS_OUTPUT.PUT_LINE('Type name : ' || v_typename);
      DBMS_OUTPUT.PUT_LINE('Value     : ' || v_typevalue);

   END generic_procedure;

BEGIN

   /* Test some inputs... */
   generic_procedure( ANYDATA.ConvertVarchar2('String value') );
   generic_procedure( ANYDATA.ConvertNumber(1234567890) );
   generic_procedure( ANYDATA.ConvertDate(DATE '1900-01-01') );

END;
/

